﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace CSharpSamples_Khoshamoz.Samples
{
    public partial class FrmSample043 : Form
    {
        public FrmSample043()
        {
            InitializeComponent();
        }

        private void btnDo_Click(object sender, EventArgs e)
        {
            var employees = new List<OOP.Employee>
            {
                new OOP.Employee("Amir","Developer",4000),
                new OOP.Employee("Hasan","DB Admin",5000),
                new OOP.Employee("Hossein","Analyst",6000),
                new OOP.Employee("Ahmad","Developer",7000),
                new OOP.Employee("Sina","Developer",6000),
                new OOP.Employee("Reza","Developer",6500),
                new OOP.Employee("Hesam","Developer",7300),
                new OOP.Employee("Mina","Developer",7500),
                new OOP.Employee("Mona","Developer",7400),
                new OOP.Employee("Maryam","Developer",7300),
                new OOP.Employee("Tina","Developer",8100),
            };

            //**************************************************************************
            //Queryable Expression Syntax : راهنمای این ساختار
            //
            //var results = 
            //          from range-variable in data-source
            //          let
            //          let
            //          where predicate
            //          select projection;
            //**************************************************************************

            var developers =
                    from d in employees
                    let isDeveloper = d.Title.Contains("Developer")
                    let isNameContainsT = d.Name.Contains("T")
                    where ((isDeveloper && d.Salary >= 8000)
                            || (isDeveloper && d.Salary <= 8000))
                            && (isNameContainsT)
                    select d;


            foreach (var item in developers)
            {
                lblResult.Text += item.ToString() + "\n";
            }



        }




    }
}
